SELECT
  count(*)-1            AS nr_statements,
  sum(loads)-max(loads) AS hard_parses,
  round((sum(sharable_mem)-max(sharable_mem))/1024/1024,3)  AS mbytes_overhead,
  max(sql_text)         AS sql_text
FROM  
  v$sqlarea 
WHERE 
  force_matching_signature<>0
GROUP BY 
  force_matching_signature,  plan_hash_value,  optimizer_env_hash_value
HAVING count(*) > 1 
ORDER BY count(*) DESC;
