CREATE TABLE AUFTRAEGE
(
  AUF_ID NUMBER
)
/

ALTER TABLE AUFTRAEGE ADD (
CONSTRAINT AUFTRAEGE_PK
PRIMARY KEY
(AUF_ID))
/


CREATE TABLE AUFTRAG_STATUS
(
AUFS_ID NUMBER,
AUFS_AUF_ID NUMBER,
AUFS_IST_VERARBEITET NUMBER(1) DEFAULT 0 NOT NULL,
AUFS_VERARBEITET_AM DATE
)
/

COMMENT ON TABLE AUFTRAG_STATUS IS 'Status - Informationen zu einem Auftrag';
COMMENT ON COLUMN AUFTRAG_STATUS.AUFS_ID IS 'technischer Primrschlssel';
COMMENT ON COLUMN AUFTRAG_STATUS.AUFS_AUF_ID IS 'Referenz auf die Auftragstabelle';
COMMENT ON COLUMN AUFTRAG_STATUS.AUFS_IST_VERARBEITET IS 'Boolean: Wurde der Auftrag bereits verarbeitet?';
COMMENT ON COLUMN AUFTRAG_STATUS.AUFS_VERARBEITET_AM IS 'Wann wurde der Auftrag verarbeitet?';

ALTER TABLE AUFTRAG_STATUS ADD (
CONSTRAINT AUFTRAG_STATUS_PK
PRIMARY KEY
(AUFS_ID))
/

ALTER TABLE AUFTRAG_STATUS ADD (
CONSTRAINT AUFTRAG_STATUS_C01
CHECK (aufs_ist_verarbeitet IN (0,1)))
/

ALTER TABLE AUFTRAG_STATUS ADD (
CONSTRAINT AUFTRAG_STATUS_R01
FOREIGN KEY (AUFS_AUF_ID)
REFERENCES AUFTRAEGE (AUF_ID))
/

