CREATE OR REPLACE FUNCTION get_fetch_process (
   p_table_name    IN   VARCHAR2,
   p_primary_key   IN   VARCHAR2,
   p_page_id       IN   NUMBER
)
   RETURN VARCHAR2
IS
   v_plsql   VARCHAR2 (4000);
BEGIN
   v_plsql :=
         'CREATE OR REPLACE PROCEDURE fetch_'
      || p_table_name
      || '_'
      || 'page_'
      || p_page_id
      || ' ('
      || 'p'
      || p_page_id
      || '_'
      || p_primary_key
      || ' IN VARCHAR2) '
      || 'AS '
      || 'BEGIN '
      || CHR (10)
      || 'FOR c IN (SELECT * FROM '
      || p_table_name
      || ' '
      || 'WHERE '
      || p_primary_key
      || ' = '
      || 'p'
      || p_page_id
      || '_'
      || p_primary_key
      || ') '
      || CHR (10)
      || 'LOOP '
      || CHR (10);

   FOR c IN (SELECT column_name
               FROM user_tab_columns
              WHERE table_name = UPPER (p_table_name)
                AND column_name NOT IN (p_primary_key))
   LOOP
      v_plsql :=
            v_plsql
         || 'apex_util.set_session_state (''P'
         || p_page_id
         || '_'
         || c.column_name
         || ''', c.'
         || c.column_name
         || '); '
         || CHR (10);
   END LOOP;
   v_plsql := v_plsql || 'END LOOP; ' || CHR (10);
   v_plsql := v_plsql || 'END; ';
   RETURN v_plsql;
END;
