DECLARE
   v_query      VARCHAR2 (4000);
   v_ename      VARCHAR2 (20);
   v_job        VARCHAR2 (20);
   v_deptno     VARCHAR2 (20);
   v_hiredate   VARCHAR2 (40);
   v_sal        VARCHAR2 (20);
BEGIN
   FOR c IN (SELECT c001, c002, c003, c004, c005
               FROM apex_collections
              WHERE collection_name = 'SEARCH_P242')
   LOOP
      v_ename := c.c001;
      v_job := c.c002;
      v_deptno := c.c003;
      v_hiredate := c.c004;
      v_sal := c.c005;
   END LOOP;

   v_query :=
         v_query
      || 'SELECT a.empno, a.ename, a.job, a.mgr, a.sal, '
      || 'a.hiredate, a.deptno '
      || 'FROM employees_tab a ';

   IF :request IN ('SEARCH', 'FETCH_ROW')
   THEN
      v_query :=
            v_query
         || 'WHERE a.deptno = '
         || CASE
               WHEN NVL (v_deptno, '0') = '0'
                  THEN 'a.deptno'
               ELSE '''' || v_deptno || ''''
            END
         || ' '
         || 'AND UPPER(a.ename) LIKE '
         || CASE
               WHEN v_ename IS NULL
                  THEN 'UPPER(a.ename)'
               ELSE '''' || UPPER (v_ename) 
                         || '''' || '||' || '''%'''
            END
         || ' '
         || 'AND a.JOB = '
         || CASE
               WHEN NVL (v_job, '0') = '0'
                  THEN 'a.job'
               ELSE '''' || v_job || ''''
            END
         || ' '
         || 'AND a.sal =  '
         || NVL (v_sal, 'a.sal')
         || ' '
         || 'AND TRUNC (a.hiredate) = '
         || CASE
               WHEN v_hiredate IS NULL
                  THEN 'TRUNC (a.hiredate)'
               ELSE 'TRUNC(TO_DATE(' || '''' 
                    || v_hiredate || ''''
                    || ',''DD-MON-YYYY''))'
            END
         || ' ';
   END IF;

   v_query := v_query || 'ORDER BY empno DESC';
   RETURN (v_query);
END;
